# wxEvent Class Reference
[Events]

`#include <wx/event.h>`

Inheritance diagram for wxEvent:
[legend]

## Detailed Description

An event is a structure holding information about an event passed to a callback or member function.

wxEvent used to be a multipurpose event object, and is an abstract base class for other event classes (see below).

For more information about events, see the Events and Event Handling overview.

wxPerl Note: In wxPerl custom event classes should be derived from `Wx::PlEvent` and `Wx::PlCommandEvent`.

##

Library: wxBase

Category: Events

See also:
  wxCommandEvent, wxMouseEvent

## Public Member Functions
| wxEvent (int id=0, wxEventType eventType=wxEVT_NULL)
| Constructor.
virtual wxEvent * | Clone () const =0
| Returns a copy of the event.
wxObject * | GetEventObject () const
| Returns the object (usually a window) associated with the event, if any.
wxEventType | GetEventType () const
| Returns the identifier of the given event type, such as `wxEVT_COMMAND_BUTTON_CLICKED`.
virtual wxEventCategory | GetEventCategory () const
| Returns a generic category for this event.
int | GetId () const
| Returns the identifier associated with this event, such as a button command id.
bool | GetSkipped () const
| Returns true if the event handler should be skipped, false otherwise.
long | GetTimestamp () const
| Gets the timestamp for the event.
bool | IsCommandEvent () const
| Returns true if the event is or is derived from wxCommandEvent else it returns false.
void | ResumePropagation (int propagationLevel)
| Sets the propagation level to the given value (for example returned from an earlier call to wxEvent::StopPropagation).
void | SetEventObject (wxObject *object)
| Sets the originating object.
void | SetEventType (wxEventType type)
| Sets the event type.
void | SetId (int id)
| Sets the identifier associated with this event, such as a button command id.
void | SetTimestamp (long timeStamp=0)
| Sets the timestamp for the event.
bool | ShouldPropagate () const
| Test if this event should be propagated or not, i.e.
void | Skip (bool skip=true)
| This method can be used inside an event handler to control whether further event handlers bound to this event will be called after the current one returns.
int | StopPropagation ()
| Stop the event from propagating to its parent window.
## Protected Attributes
int | m_propagationLevel
| Indicates how many levels the event can propagate.

List of all members.

## Constructor & Destructor Documentation

wxEvent::wxEvent | ( | int | id = `0`,
|  | wxEventType | eventType = `wxEVT_NULL` |
| ) |  |  |

Constructor.

Notice that events are usually created by wxWidgets itself and creating e.g. a wxPaintEvent in your code and sending it to e.g. a wxTextCtrl will not usually affect it at all as native controls have no specific knowledge about wxWidgets events. However you may construct objects of specific types and pass them to wxEvtHandler::ProcessEvent() if you want to create your own custom control and want to process its events in the same manner as the standard ones.

Also please notice that the order of parameters in this constructor is different from almost all the derived classes which specify the event type as the first argument.

Parameters:

  | id | The identifier of the object (window, timer, ...) which generated this event.
  | eventType | The unique type of event, e.g. `wxEVT_PAINT`, `wxEVT_SIZE` or `wxEVT_COMMAND_BUTTON_CLICKED`.

## Member Function Documentation

virtual wxEvent* wxEvent::Clone | ( |  | ) | const`[pure virtual]`

Returns a copy of the event.

Any event that is posted to the wxWidgets event system for later action (via wxEvtHandler::AddPendingEvent, wxEvtHandler::QueueEvent or wxPostEvent()) must implement this method.

All wxWidgets events fully implement this method, but any derived events implemented by the user should also implement this method just in case they (or some event derived from them) are ever posted.

All wxWidgets events implement a copy constructor, so the easiest way of implementing the Clone function is to implement a copy constructor for a new event (call it MyEvent) and then define the Clone function like this:

            wxEvent *Clone() const { return new MyEvent(*this); }

Implemented in wxThreadEvent, and wxRichTextEvent.

virtual wxEventCategory wxEvent::GetEventCategory | ( |  | ) | const`[virtual]`

Returns a generic category for this event.

wxEvent implementation returns `wxEVT_CATEGORY_UI` by default.

This function is used to selectively process events in wxEventLoopBase::YieldFor.

Reimplemented in wxThreadEvent.

wxObject* wxEvent::GetEventObject | ( |  | ) | const

Returns the object (usually a window) associated with the event, if any.

wxEventType wxEvent::GetEventType | ( |  | ) | const

Returns the identifier of the given event type, such as `wxEVT_COMMAND_BUTTON_CLICKED`.

int wxEvent::GetId | ( |  | ) | const

Returns the identifier associated with this event, such as a button command id.

bool wxEvent::GetSkipped | ( |  | ) | const

Returns true if the event handler should be skipped, false otherwise.

long wxEvent::GetTimestamp | ( |  | ) | const

Gets the timestamp for the event.

The timestamp is the time in milliseconds since some fixed moment (not necessarily the standard Unix Epoch, so only differences between the timestamps and not their absolute values usually make sense).

Warning:
  wxWidgets returns a non-NULL timestamp only for mouse and key events (see wxMouseEvent and wxKeyEvent).

bool wxEvent::IsCommandEvent | ( |  | ) | const

Returns true if the event is or is derived from wxCommandEvent else it returns false.

Note:
  exists only for optimization purposes.

void wxEvent::ResumePropagation | ( | int | propagationLevel | ) |

Sets the propagation level to the given value (for example returned from an earlier call to wxEvent::StopPropagation).

void wxEvent::SetEventObject | ( | wxObject * | object | ) |

Sets the originating object.

void wxEvent::SetEventType | ( | wxEventType | type | ) |

Sets the event type.

void wxEvent::SetId | ( | int | id | ) |

Sets the identifier associated with this event, such as a button command id.

void wxEvent::SetTimestamp | ( | long | timeStamp = `0` | ) |

Sets the timestamp for the event.

bool wxEvent::ShouldPropagate | ( |  | ) | const

Test if this event should be propagated or not, i.e.

if the propagation level is currently greater than 0.

void wxEvent::Skip | ( | bool | skip = `true` | ) |

This method can be used inside an event handler to control whether further event handlers bound to this event will be called after the current one returns.

Without Skip() (or equivalently if Skip(false) is used), the event will not be processed any more. If Skip(true) is called, the event processing system continues searching for a further handler function for this event, even though it has been processed already in the current handler.

In general, it is recommended to skip all non-command events to allow the default handling to take place. The command events are, however, normally not skipped as usually a single command such as a button click or menu item selection must only be processed by one handler.

int wxEvent::StopPropagation | ( |  | ) |

Stop the event from propagating to its parent window.

Returns the old propagation level value which may be later passed to ResumePropagation() to allow propagating the event again.

## Member Data Documentation

int wxEvent::m_propagationLevel`[protected]`

Indicates how many levels the event can propagate.

This member is protected and should typically only be set in the constructors of the derived classes. It may be temporarily changed by StopPropagation() and ResumePropagation() and tested with ShouldPropagate().

The initial value is set to either `wxEVENT_PROPAGATE_NONE` (by default) meaning that the event shouldn't be propagated at all or to `wxEVENT_PROPAGATE_MAX` (for command events) meaning that it should be propagated as much as necessary.

Any positive number means that the event should be propagated but no more than the given number of times. E.g. the propagation level may be set to 1 to propagate the event to its parent only, but not to its grandparent.

|  | [ top ]